// ̃o[Wł͈ꕔADigital[hŕs邪
// ̂܂܂ƂB
//
// Digital[hŁuXbgvsƁA
// {^3,4,5,6,13ꂽԂɂȂA\L[EɂȂĂ܂B
// WCXeBbNǂݎ胋[`딻肵Ă邩H

#include "joystick.h"

#define LOOPMAX 1200    // 508.7us    162.56us҂
#define WAIT_CS    Delay10TCYx(25)   // 27.7us
#define WAIT_CS_D  Delay10TCYx(6)   // 10us
#define CS_DATA    ((PORTC) & 0x0f)
#define CS_LH      (PORTCbits.RC4)
#define CS_ACK     (PORTCbits.RC6)
#define CS_REQ_L     LATC = 0x00
#define CS_REQ_H     LATC = 0x20
#define CS_WAIT_NEXTPOLL    Delay1KTCYx(61) // 83usec x 61 = 5063usec = 5msec
//#define CS_WAIT_NEXTPOLL    Delay1KTCYx(90) // 83usec x 90 = 7470usec = 7.4msec

// Prottype@definition
void PrepareForReadKabutogani(void);
bool ReadPhaseDataKG(unsigned char *phaseData);


/// -------------------------------------------------------
/// ǂݎ菀i|[gݒȂǁj
/// -------------------------------------------------------
void PrepareForReadKabutogani(void)
{
    // PortC Initialize port IN/OUT direction
    TRISC = 0b11011111;         // SELóA͓

    // 
    CS_REQ_H;
    WAIT_PORTSET;
}


/// -------------------------------------------------------
/// ǂݎ聕WCXeBbNo̓f[^쐬
/// iTCo[XeBbN/JugKjj
/// -------------------------------------------------------
bool ReadKabutogani
    (char *devType, int *buttons)
{
	// ǂݎsƁAȉ3P[Xꂩ
	// 1.AiOǂݐUSB荞ݖ
	// 2.AiOǂݐUSB荞ݗL
	// 3.AiOǂݎs(̂ŁAUSB荞ݏɗLH)
	// 
	// foCX
	//   ԁFsȃfoCXƂB
	//
	//   ?ǂݎ菈
	//     ʂɂ蕪
	//     1̏ꍇAiOXeBbNƔBG[JEg0Zbg
	//              ?-a
	//
	//     2,3̏ꍇG[JEg20A
	//                  {1AȂreturn
	//                Ȃ΁A
	//                  ?-b
	//
	//   ?-a AiOXeBbN̏USBo
	//   ?-b fW^XeBbN̏USBo
    unsigned char phaseData[12];
    unsigned char phaseData_D[2];
    bool isAnalog = false;
    bool state = true;

    static unsigned int counter_Failed = 0;

	// sfoCXA
    if(*devType == DEVTYPE_UNKNOWN)
    {
        PrepareForReadKabutogani();
    }

	// USB荞ݔtO
	//		OFFAONɕςĂ
	//		USBǂݎ肪Ƃ
    G_USBINT = false;	// USB荞ݔtOOFF

	// ?ǂݎ菈
    // Read
    state = ReadPhaseDataKG(phaseData);


	// ʂɂ蕪
    if(state && G_USBINT == false)
    {
		// 1.AiOǂݐUSB荞ݖ
		counter_Failed = 0;
        isAnalog = true;
        *devType = DEVTYPE_KABUTOGANI;
	}
	else
	{
		// 2.AiOǂݐUSB荞ݗL
		// 3.AiOǂݎs(̂ŁAUSB荞ݏɗLH)
		if(counter_Failed < 20)
		{
			counter_Failed++;
			return false;
		}
		else
		{
			isAnalog = false;
	        *devType = DEVTYPE_UNKNOWN;
		}
    }
	
    // USBo
    if(isAnalog)
    {

        //Buttons
        *buttons = 0x00000000 |
            ((!(phaseData[0]&0b0010) &&  (phaseData[0]&0b0001)) ? BTNBIT_01 : 0) | // C
            ((!(phaseData[0]&0b0100) &&  (phaseData[0]&0b0001)) ? BTNBIT_02 : 0) |  // B
            ((!(phaseData[0]&0b1000) &&  (phaseData[0]&0b0001)) ? BTNBIT_03 : 0) |  // A
            ((!(phaseData[0]&0b0100) && !(phaseData[0]&0b0001)) ? BTNBIT_04 : 0) |  // B+D
            ((!(phaseData[1]&0b1000) &&  (phaseData[0]&0b0001)) ? BTNBIT_05 : 0) |  // E1
            ((!(phaseData[1]&0b0100) &&  (phaseData[0]&0b0001)) ? BTNBIT_06 : 0) |  // E2
            ((!(phaseData[1]&0b1000) && !(phaseData[0]&0b0001)) ? BTNBIT_07 : 0) |  // E1+D
            ((!(phaseData[1]&0b0100) && !(phaseData[0]&0b0001)) ? BTNBIT_08 : 0) |  // E2+D
            ((!(phaseData[1]&0b0001) &&  (phaseData[0]&0b0001)) ? BTNBIT_09 : 0) |  // G(Mode)
            ((!(phaseData[1]&0b0010) &&  (phaseData[0]&0b0001)) ? BTNBIT_10 : 0) |  // F(Start)
            ((!(phaseData[0]&0b1000) && !(phaseData[0]&0b0001)) ? BTNBIT_11 : 0) |  // A+D
            ((!(phaseData[0]&0b0010) && !(phaseData[0]&0b0001)) ? BTNBIT_12 : 0) |  // C+D
            ((!(phaseData[1]&0b0010) && !(phaseData[0]&0b0001)) ? BTNBIT_13 : 0) ;  // F(Start)+D

        //Analog sticks
        joystick_input.val[3] = (phaseData[ 3]<<4) | phaseData[ 7]; // X
        joystick_input.val[4] = (phaseData[ 2]<<4) | phaseData[ 6]; // Y
        // W̃JugKj/TCo[XeBbNɂ4ڂ͖B
        // ̍sLɂƁAXvgD[2Ȃǂŉ葱Ă܂̂
        // 萔ŒɂĂ
//      joystick_input.val[5] = (phaseData[ 5]<<4) | phaseData[ 9]; // Z
        joystick_input.val[5] = ANALOG_NEUTRAL;                               // Z
        joystick_input.val[6] = (phaseData[ 4]<<4) | phaseData[ 8]; // Rz

        //Hat switch
        unsigned char hatswitch = 0x0f;
        bool blnUp      = ((joystick_input.val[4]<0x10) && !(phaseData[0]&0b0001));
        bool blnDown    = ((joystick_input.val[4]>0xf0) && !(phaseData[0]&0b0001));
        bool blnRight   = ((joystick_input.val[3]>0xf0) && !(phaseData[0]&0b0001));
        bool blnLeft    = ((joystick_input.val[3]<0x10) && !(phaseData[0]&0b0001));


        // If D pressed, set analog stick to center. And set Z
        // D{^AXbgőȂ𑀍ł悤ɂ
        if(!(phaseData[0]&0b0001))
        {
            joystick_input.val[3] = ANALOG_NEUTRAL;
            joystick_input.val[4] = ANALOG_NEUTRAL;
            joystick_input.val[5] = (phaseData[ 4]<<4) | phaseData[ 8];
            joystick_input.val[6] = ANALOG_NEUTRAL;
        }

        if ( blnUp )    // up
        {
            hatswitch = HAT_SWITCH_NORTH;
            if ( blnRight ) // right
            {
                hatswitch = HAT_SWITCH_NORTH_EAST;
            }
            if ( blnLeft)  // left
            {
                hatswitch = 7;
            }
        }
        else if ( blnRight )    // right
        {
            hatswitch = 2;
            if ( blnDown )   // down
            {
                hatswitch = 3;
            }
        }
        else if ( blnDown ) // down
        {
            hatswitch = 4;
            if ( blnLeft )  // left
            {
                hatswitch = 5;
            }
        }
        else if ( blnLeft ) // left
        {
            hatswitch = 6;
        }
        else
        {
            hatswitch = HAT_SWITCH_NULL;
        }
        joystick_input.val[2] = hatswitch;

        //Send the packet over USB to the host.
        //lastTransmission = HIDTxPacket(JOYSTICK_EP, (uint8_t*)&joystick_input, sizeof(joystick_input));
    }
    else
    {
        phaseData_D[1] = (PORTC & 0x0f) | (CS_LH << 4) | (CS_ACK << 5);
        CS_REQ_L;
        WAIT_CS_D;
        phaseData_D[0] = (PORTC & 0x0f) | (CS_LH << 4) | (CS_ACK << 5);
        CS_REQ_H;
		
        //Buttons
        *buttons = 0x00000000 |
            ((phaseData_D[0]&0b010000) ? 0 : BTNBIT_01) |  // A
            ((phaseData_D[0]&0b100000) ? 0 : BTNBIT_02) |  // B
            ((phaseData_D[1]&0b000001) ? 0 : BTNBIT_03) |  // ThrUp
            ((phaseData_D[1]&0b000010) ? 0 : BTNBIT_04) |  // ThrDown
            ((phaseData_D[1]&0b000100) ? 0 : BTNBIT_05) |  // C
            ((phaseData_D[1]&0b001000) ? 0 : BTNBIT_06) |  // D
            ((phaseData_D[1]&0b010000) ? 0 : BTNBIT_07) |  // E1
            ((phaseData_D[1]&0b100000) ? 0 : BTNBIT_08) ;  // E2

        Set_AnalogAndHatValue(
                (phaseData_D[0]&0b001000),     // R
                (phaseData_D[0]&0b000100),     // L
                (phaseData_D[0]&0b000001),     // U
                (phaseData_D[0]&0b000010));    // D
    }
	
	// ǂݎ܂5msec悤ɂ
    CS_WAIT_NEXTPOLL;
	
    return true;
}

/// --------------------------------------------------------------------------
/// Read function
/// --------------------------------------------------------------------------
bool ReadPhaseDataKG(unsigned char *phaseData)
{
    unsigned int  count = 0;
    bool state = true;

	/*
	// 1/4{[h
	// ςȂɂ
    CS_REQ_L;
	*/
	
	
    // REQ グ
    CS_REQ_L;
    WAIT_CS;
    CS_REQ_H;
	

    for(int i=0; i<12; i+=2)
    {
        // wait ACK==L
        count = 0;
        while(CS_ACK == 1)
        {
            count++;
            if(count > LOOPMAX)
            {
                state = false;
                break;
            }
        }

        if(!state)
        {
            break;
        }

        // ACK==L
        phaseData[i] = CS_DATA;

        // WAIT LH==1
        count = 0;
        while(CS_LH == 0)
        {
            count++;
            if(count > LOOPMAX)
            {
                state = false;
                break;
            }
        }

        if(!state)
        {
            break;
        }

        // wait ACK==L
        count = 0;
        while(CS_ACK == 1)
        {
            count++;
            if(count > LOOPMAX)
            {
                state = false;
                break;
            }
        }

        if(!state)
        {
            break;
        }

        // ACK==L
        phaseData[i+1] = CS_DATA;

        // wait LH==L
        count = 0;
        while(CS_LH == 1)
        {
            count++;
            if(count > LOOPMAX)
            {
                state = false;
                break;
            }
        }

        if(!state)
        {
            break;
        }
    }
	
	/*
	// 1/4{[h
	// グ
    CS_REQ_H;
	*/
	
    return state;
}
